--notes: minerals in middle so less boring during full FFA
--slower creep to middle
--


---
function gadget:GetInfo()
  return {
    name      = "feature spawner",
    desc      = "minerals spawn in rectangular areas which can move",
    author    = "knorke",
    date      = "Feb 2012 ",
    license   = "GNU GPL, v2 or later or horse",
    layer     = 0,
    enabled   = true,  --  loaded by default?
  }
end

if not gadgetHandler:IsSyncedCode() then
  return false -- no unsynced code
end

local mapOptions = Spring.GetMapOptions()

--mapoptions--
Spring.Echo ("reading mapoptions")
--middle
local middleRes = true
local teamn = #Spring.GetTeamList() -1
if teamn == 2 then middleRes = false end
Spring.Echo ("teamn:"..teamn)
if (mapOptions) then
	local o = mapOptions["middle"]
	if o == "yes" then middleRes = true end
	if o == "no" then middleRes = false end
	Spring.Echo ("mapoption middle:" .. (o or "nil"))
end



--resources	
local s = 200	--size of areas
local initialMineralsPerArea = 5
local spawnRate = 30
local maxFeaturesPerSpawnArea = 10
if (mapOptions) then
	local o = mapOptions["resources"]
	if o == "low" then spawnRate = 120 end
	if o == "high" then spawnRate = 25 maxFeaturesPerSpawnArea = 20 end
	if o == "madness" then spawnRate = 30 maxFeaturesPerSpawnArea = 50 initialMineralsPerArea = 15 s= 600 end
	Spring.Echo ("mapoption resources:" .. (o or "nil"))
end

--creep
local creepStartFrame = 30*60* 15
local creepSpeed = 20
if (mapOptions) then
	local o = mapOptions["creep"]
	if o == "slow" then creepStartFrame = 30*60* 25 creepSpeed = 10 end
	if o == "slowbutsteady" then creepStartFrame = 30*60* 2 creepSpeed = 2 end
	Spring.Echo ("mapoption creep:" .. (o or "nil"))
end

--------------

local GaiaTeamID  = Spring.GetGaiaTeamID ()

local spawnAreas = {}
local mapx=7168
local mapz=7168
local mapcx=mapx/2
local mapcz=mapz/2
local r = 2700
local i = 0

local i  = 0
for x = -1,1 do
	for z = -1,1 do
		if not (x==0 and z == 0) or middleRes then	--no middle res spot
		local xp = mapcx+ (r*x)
		local zp = mapcz+ (r*z)
		i = i+1
		spawnAreas[i] = {x1=xp-s, z1=zp-s,  x2=xp+s, z2=zp+s}
		end
	end
end



function RemoveFeatures ()
	local all_features = Spring.GetAllFeatures ()
	for i in pairs(all_features) do		
		Spring.DestroyFeature (all_features[i])
	end
end

function gadget:Initialize()
	Spring.Echo ("Hey I am the minerals spawn gadget")
	--RemoveFeatures()

	for i = 1, #spawnAreas do
		for n = 1, initialMineralsPerArea do
			local x = math.random (spawnAreas[i].x1, spawnAreas[i].x2)
			local z = math.random (spawnAreas[i].z1, spawnAreas[i].z2)
			local y = Spring.GetGroundHeight (x,z)
			Spring.CreateFeature ("mapf_tiberium",  x, y, z, math.random (0,32000), GaiaTeamID)
		end
	end
end


function gadget:GameFrame(frame)
	if frame > creepStartFrame and frame % 60 == 0 then toMiddle (i) end
	if frame % (spawnRate) ~=0 then return end
	for i = 1, #spawnAreas do
		local f = Spring.GetFeaturesInRectangle (spawnAreas[i].x1, spawnAreas[i].z1, spawnAreas[i].x2, spawnAreas[i].z2)
		if #f < maxFeaturesPerSpawnArea then
			local x = math.random (spawnAreas[i].x1, spawnAreas[i].x2)
			local z = math.random (spawnAreas[i].z1, spawnAreas[i].z2)
			local y = Spring.GetGroundHeight (x,z)
			local fid = Spring.CreateFeature ("mapf_tiberium",  x, y, z, math.random (0,32000), GaiaTeamID)
			if fid then Spring.SpawnCEG ("map_mineralspawn", x,y,z) end
		end
	end	
end

function toMiddle ()
	for i = 1, #spawnAreas do
		local cx = (spawnAreas[i].x1+spawnAreas[i].x2) /2 
		local cz = (spawnAreas[i].z1+spawnAreas[i].z2) /2 
		cx = approach (cx, mapcx , creepSpeed)
		cz = approach (cz, mapcx , creepSpeed)
		spawnAreas[i] = {x1=cx-s, z1=cz-s,  x2=cx+s, z2=cz+s}	--FIXME use actual dimension
	end
end

function approach (currentX, targetX, speed)
	local newX = currentX
	local diff = currentX - targetX
	local hasReached = false
	if (math.abs (diff) < speed) then
		currentX = targetX
		hasReached = true
	else
		if diff < 0 then 
			newX = newX + speed
		else 
			newX = newX - speed
		end
	end
	return newX, hasReached, newX-currentX
end
